<?php 

function getFilterFields($activeOnly=1) {

	$filterFields = array();

	$query = "SELECT * FROM filterFields";

	if ($activeOnly != 0)
		$query .= " WHERE isActive IS NULL OR isActive=1";

	$result = $_ENV['appDB']->query($query);

	while ($row = mysql_fetch_assoc($result)) {

		$filterFields[] = $row;

	}

	return $filterFields;

}

function getFilterFieldByID($id) {

	$query = "SELECT * FROM filterFields WHERE id = " . $id;

	$result = $_ENV['appDB']->query($query);

	$row = mysql_fetch_assoc($result);

	return $row;

}

function buildFormTag($filter) {

	$filterHTML = $filter['name'] . "&nbsp;<input name=\"filterID" . $filter['id'] . "\" type=\"" . $filter['filterFormType'] . "\"";
	
	if ($filter['defaultValue'])
		$filterHTML .= " value=\"" . $filter['defaultValue'] . "\"";

	$filterHTML .= ">";

	return $filterHTML;

}

function buildQuery($baseTable,$filterFieldsIDsAndValues,$orderField="",$orderDirection="",$limit="",$baseFieldsToReturn=array("*"),$matchAll=true) {

	$joinedTables = array();
	$queryWhereClauses = array();
	$queryFields = array();
	$orderFields = array();
	$usedTableNames = array();

	if ($orderField && $orderField != "" && !strpos($orderField,"."))
		$orderField = $baseTable . "." . $orderField;

	foreach ($baseFieldsToReturn AS $thisFieldToReturn) {

		if (!strpos($thisFieldToReturn,"."))
			$queryFields[] = $baseTable . "." . $thisFieldToReturn;
		else
			$queryFields[] = $thisFieldToReturn;

	}

	foreach ($filterFieldsIDsAndValues AS $thisFilter) {

		$thisFilterDetails = getFilterFieldByID($thisFilter['id']);

		if (strtolower($thisFilterDetails['dbTableName']) == strtolower($baseTable)) {

			$whereTableName = $baseTable;

		} else {

			$tmpJoin = "";

			if ($thisFilterDetails['useCurrentDatastore'] && $thisFilterDetails['useCurrentDatastore'] == 1)
				$thisFilterDetails['dbTableName'] = str_replace("DATASTORE",$_SESSION['user']['activeSearchStore'],$thisFilterDetails['dbTableName']);

			if (!$thisFilter['joinTable'])
				$thisFilter['joinTable'] = $baseTable;

			if ($thisFilter['joinType']) {

				$tmpJoin = strtoupper($thisFilter['joinType']) . " ";

			} elseif ($thisFilterDetails['joinType']) { 

				$tmpJoin = strtoupper($thisFilterDetails['joinType']) . " ";
				
			} else {

				$tmpJoin = "INNER JOIN ";

			}

			$nameCount = 1;

			if (!$thisFilter['joinField'])
				$thisFilter['joinField'] = "id";

			while (in_array(strtolower($thisFilterDetails['dbTableName']) . $nameCount,$usedTableNames)) {

				$nameCount++;
			}

			$usedTableNames[] = strtolower($thisFilterDetails['dbTableName']) . $nameCount;
			$whereTableName = strtolower($thisFilterDetails['dbTableName']) . $nameCount;
			
			$joinedTables[] = $tmpJoin . strtolower($thisFilterDetails['dbTableName']) . " AS " . $whereTableName . " ON (" . $whereTableName  . "." . $thisFilterDetails['dbFieldName'] . " = " . $thisFilter['joinTable'] . "." . $thisFilter['joinField'] . ")";

		}
		
		$thisWhereClause = $whereTableName . "." . $thisFilterDetails['dbFieldName'] . " ";

		if ($thisFilter['fieldComparisonOperator'])
			$thisWhereClause .= $thisFilter['fieldComparisonOperator'] . " ";
		elseif ($thisFilterDetails['fieldComparisonOperator'])
			$thisWhereClause .= $thisFilterDetails['fieldComparisonOperator'] . " ";
		else
			$thisWhereClause .= "= ";

		if (strtolower($thisFilterDetails['dataType']) == "string") {
			
			$thisWhereClause .= "'";
			
			$thisFilter['value'] = str_replace("'", "\\'", $thisFilter['value']);
			
		}

		$thisWhereClause .= " " . $thisFilter['value'];

		if (strtolower($thisFilterDetails['dataType']) == "string")
			$thisWhereClause .= "'";
		
		$queryWhereClauses[] = $thisWhereClause;
		
		if ($thisFilter['returnFields']) {
			
			if (!is_array($thisFilter['returnFields']))
				$queryFields[] = $whereTableName . "." . $thisFilter['returnFields'];
			else {
				
				foreach ($thisFilter['returnFields'] as $thisReturnField) {
					
					$queryFields[] = $whereTableName . "." . $thisReturnField;
					
				}
				
			}

		}

		if ($thisFilter['orderField'])
			$orderFields[] = $whereTableName . "." . $thisFilter['orderField'];
	}

	// Initialize query with fields to return
	$query = "SELECT " . implode(", ",$queryFields) . " FROM " . $baseTable . " ";

	// Add any joins to query
	if (count($joinedTables) >= 1)
		$query .= implode(" ",$joinedTables);

	// Tack on any 'WHERE' clauses
	if (count($queryWhereClauses) >= 1) {

		$query .= " WHERE ";

		if ($matchAll)
			$query .= implode(" AND ",$queryWhereClauses);
		else
			$query .= implode(" OR ",$queryWhereClauses); 

	}
	
	// Set the order
	if (count($orderFields) >= 1) {

		if ($orderField && $orderField != "")
			$orderField .= ",";

		$orderField .= implode(",",$orderFields);

	}
	
	if ($orderField && $orderField != "") {
		
		$query .= " ORDER BY " . $orderField;
		
		if ($orderDirection && (strtolower($orderDirection) != "asc" || strtolower($orderDirection) != "desc"))
			$query .= " " . strtoupper($orderDirection);

	}

	// Limit the query
	if ($limit && is_numeric($limit) && $limit > 0)
		$query .= " LIMIT " . str_replace(".","",$limit);

	return $query;
	
}

?>