<?php

function networkScanningProcessor() {
	
	$interval = ops("site_networkScanningInterval");
	
	$q = $_ENV['appDB']->query("SELECT * FROM idsNetworks WHERE networkScanning = 1");
	while ($row = mysql_fetch_assoc($q)) {
	
		if (($row['networkScanningLast'] + $interval) < time()) {
	
			// Run scan
			
			$_ENV['appLog']->log('CONSOLE', "Scanning " . $row['network']);
			
			$results = runNmapNetworkScan($row['network'], "-n -sn");
			
			if ($results) {
			
				// Store results
				
				// Update last run
				
				$_ENV['appDB']->query("UPDATE idsNetworks SET networkScanningLast = '" . time() . "' WHERE id = '" . $row['id'] . "'");

				// Reset up / down state

				resetNmapNetworkScanState($row['network']);
				
				// Process results
				
				$resultArray = processNmapNetworkScanXML($results);
				
				// Dispatch console event

				$_ENV['appLog']->log('CONSOLE', $resultArray['newHostsTotal'] . " new host(s) found during automated network scan of " . $row['network']);

				if ($resultArray['newHostsTotal'] > 0) {
				
					$object = arrayToObject(array("signatureName" => $resultArray['newHostsTotal'] . " new host(s) found during automated network scan of " . $row['network'], "signatureID" => "3333001", "risk" => 1, "payload" => implode(", ", $resultArray['newHosts'])));
				
				} else {

					$object = arrayToObject(array("signatureName" => $resultArray['newHostsTotal'] . " new host(s) found during automated network scan of " . $row['network'], "signatureID" => "3333000", "risk" => 5, "payload" => implode(", ", $resultArray['newHosts'])));

				}
				
				insertConsoleEvent($object);				
				
			} else {
				
				// No results				
				
				$_ENV['appLog']->log('ERROR', "Scan results returned invalid data");
				
			}
			
		}
		
	}

}

function runNmapNetworkScan($network, $options) {
	
	$nmapBinary = ops("site_nmapBinaryLocation");
	
	if (!@file_exists(ops("site_nmapBinaryLocation"))) {
	
		return 0;
		
	}
	
	$filename = "tmp/nmapResults-G-" . time() . ".dat";
	
	$optionsString = "$options $network";
	
	$fileOutString = "-oX " . $filename;
	
	$timeMaxString = "--host-timeout 10s";
	
    $tmpExec = `$nmapBinary $optionsString $timeMaxString $fileOutString $targetString 2>&1`;		     
	
	if (@file_exists($filename)) {
		
		$_ENV['appLog']->log('DEBUG', "Scan results for $network were written");
		
		$return = @file_get_contents($filename);
		@unlink($filename);

		return $return;
		
	} else {

		$_ENV['appLog']->log('DEBUG', "Scan results for $network were NOT written");
	
		return 0;
		
	}	
	
}

function runNmapHostScan($ip, $options) {
	
	$nmapBinary = ops("site_nmapBinaryLocation");
	
	if (!@file_exists(ops("site_nmapBinaryLocation"))) {
	
		return 0;
		
	}
	
	$filename = "tmp/nmapResults-G-" . time() . ".dat";
	
	$optionsString = "$options $ip";
	
	$fileOutString = "-oX " . $filename;
	
//	$timeMaxString = "--host-timeout 90s";
	
    $tmpExec = `$nmapBinary $optionsString $timeMaxString $fileOutString $targetString 2>&1`;		     
	
	if (@file_exists($filename)) {
		
		$_ENV['appLog']->log('DEBUG', "Scan results for $ip were written");
		
		$return = @file_get_contents($filename);
		@unlink($filename);

		return $return;
		
	} else {

		$_ENV['appLog']->log('DEBUG', "Scan results for $ip were NOT written");
	
		return 0;
		
	}	
	
}

function processNmapNetworkScanXML($rawXML) {
	
	$newHostsTotal = 0;
	$newHosts = array();
	
	$xmlObj = new SimpleXMLElement($rawXML);
	
//	echo "Hosts up: " . $xmlObj->runstats->hosts['up'] . "\n";
	
	$_ENV['appLog']->log('DEBUG', "Network scan hosts up: " . $xmlObj->runstats->hosts['up']);
	
	foreach ($xmlObj->host as $host) {
		
		if ($host->status['reason'] == "reset") continue;
		
		$q = $_ENV['appDB']->query("SELECT * FROM idsDeviceAddresses WHERE ip = '" . ipToLong($host->address[0]['addr']) . "'");
		if (mysql_num_rows($q) > 0) {
			
			// Found
			
			while ($row = mysql_fetch_assoc($q)) {

				$_ENV['appDB']->query("UPDATE idsDeviceMeta SET value = '" . $host->status['state'] . "' WHERE name = 'State' AND deviceID = '" . $row['deviceID'] . "'");
				$_ENV['appDB']->query("UPDATE idsDeviceMeta SET value = '" . $host->status['reason'] . "' WHERE name = 'State Reason' AND deviceID = '" . $row['deviceID'] . "'");
			
			}
			
		} else {
			
			// Not found
	
			$newHostsTotal++;
			$newHosts[] = $host->address[0]['addr'];
			
			$q = $_ENV['appDB']->query("INSERT INTO idsDevices (name, description, type, intime) VALUES ('" . $host->address[0]['addr'] . "', 'Discovered " . date(ops("site_timeDateFormat")) . "', '19', '" . time() . "') ");
			
			$lastInsertID = mysql_insert_id($_ENV['appDB']->link);
			
			if ($host->address[0]['addrtype'] == "ipv4") { $ipv4 = 1; } else { $ipv4 = 0; }
			if ($host->address[0]['addrtype'] == "ipv6") { $ipv6 = 1; } else { $ipv6 = 0; }
			
			$_ENV['appDB']->query("INSERT INTO idsDeviceAddresses (deviceID, name, ip, MAC, ipv4, ipv6, intime) VALUES ('" . $lastInsertID . "', 'eth', '" . ipToLong($host->address[0]['addr']) . "', '" . $host->address[1]['addr'] . "', '$ipv4', '$ipv6', '" . time() . "')");
			
			// Meta
			
			$_ENV['appDB']->query("INSERT INTO idsDeviceMeta (deviceID, name, value, intime) VALUES ('" . $lastInsertID . "', 'State', '" . $host->status['state'] . "', '" . time() . "')");
			$_ENV['appDB']->query("INSERT INTO idsDeviceMeta (deviceID, name, value, intime) VALUES ('" . $lastInsertID . "', 'State Reason', '" . $host->status['reason'] . "', '" . time() . "')");
			
			if ($host->address[1]['vendor']) {
				$_ENV['appDB']->query("INSERT INTO idsDeviceMeta (deviceID, name, value, intime) VALUES ('" . $lastInsertID . "', 'Vendor', '" . $host->address[1]['vendor'] . "', '" . time() . "')");
			}

		}
		
	}
	
	return array("newHostsTotal" => $newHostsTotal, "newHosts" => $newHosts);
	
}

function resetNmapNetworkScanState($network) {
	
	$tmpArray = explode("-", cidrconv($network));
	$tmpArray[0] = ipToLong($tmpArray[0]);
	$tmpArray[1] = ipToLong($tmpArray[1]);

	$q = $_ENV['appDB']->query("SELECT * FROM idsDeviceAddresses WHERE ip BETWEEN " . implode(" AND ", $tmpArray) . "");
	while ($row = mysql_fetch_assoc($q)) {
	
		$deviceArray[] = $row['deviceID'];
	
	}
	
	if ($deviceArray) {
	
		$_ENV['appDB']->query("UPDATE idsDeviceMeta SET value = 'down' WHERE name = 'State' AND deviceID IN (" . implode(",", $deviceArray) . ")");
		$_ENV['appDB']->query("UPDATE idsDeviceMeta SET value = '' WHERE name = 'State Reason' AND deviceID IN (" . implode(",", $deviceArray) . ")");
		
	}

}

function offensiveReconnaissanceScan($id) {
	
	$q = $_ENV['appDB']->query("SELECT * FROM idsReconnaissanceResults WHERE id = '$id'");
	while ($row = mysql_fetch_assoc($q)) {

		$host = $row['host'];

	}

	$results = runNmapHostScan($host, ops("site_nmapOffensiveReconnaissanceOptions"));
		
	if ($results) {

		// Results

		$_ENV['appLog']->log('DEBUG', "Scan results for $host returned data");
	
		// Store results
		
		$_ENV['appDB']->query("UPDATE idsReconnaissanceResults SET data = '" . addslashes($results) . "' WHERE id = '$id'");
		
	} else {
		
		// No results				
		
		$_ENV['appLog']->log('ERROR', "Scan results returned invalid data");
		
	}
		
}

?>