<?php

function prv_actionManagement() {

	// Build renderers

	$_ENV['templateRenderer'] = displayActionsByUserID($_SESSION['user']['id']);

	// Get details

	$_ENV['templateData'] = actionDetails(sanitize("id"));

	// Template

	$_ENV['contentTitle'] = "Action Management";

	$_ENV['template'] = "template_actionManagement.php";

}

function prv_actionManagementEdit() {

	// Build renderers

	$_ENV['templateRenderer'] = displayActionsByUserID($_SESSION['user']['id']);

	// Get details

	$_ENV['templateData'] = actionDetails(sanitize("id"));

	// Template

	$_ENV['contentTitle'] = "Action Management > Edit";

	$_ENV['template'] = "template_actionManagementEdit.php";

}

function displayAllOtherActions() {
	
	// Actions list

	$q = $_ENV['appDB']->query("SELECT * FROM idsActionMaster WHERE userid != '" . $_SESSION['user']['id'] . "' ORDER BY id");
	while ($row = mysql_fetch_assoc($q)) {
	
		if (!getVar("id")) setVar("id", $row['id']);
	
		$out .= itemRenderer('actionManagement', $row);	
		
	}
	
	return $out;

}

function displayActionsByUserID($id) {
	
	// Actions list

	$q = $_ENV['appDB']->query("SELECT * FROM idsActionMaster WHERE userid = '" . $id . "' ORDER BY id");
	while ($row = mysql_fetch_assoc($q)) {
	
		if (!getVar("id")) setVar("id", $row['id']);
		
		$out .= itemRenderer('actionManagement', $row);
		
	}
	
	return $out;

}

function actionDetails($id) {
	
	$q = $_ENV['appDB']->query("SELECT * FROM idsActionMaster WHERE id = '$id'");
	$result = mysql_fetch_object($q);
	
	return $result;
	
}

function displayMatchCriteria() {
	
	$q = $_ENV['appDB']->query("SELECT * FROM idsActionStore WHERE masterid = '" . sanitize("id") . "' AND class = '1' ORDER BY id");
	while ($row = mysql_fetch_assoc($q)) {
	
		$out .= itemRenderer('actionMatchCriteria', $row);	
		
	}
	
	return $out;

}

function displayMatchActions() {
	
	$q = $_ENV['appDB']->query("SELECT * FROM idsActionStore WHERE masterid = '" . sanitize("id") . "' AND class = '2' ORDER BY id");
	while ($row = mysql_fetch_assoc($q)) {
	
		$out .= itemRenderer('actionMatchActions', $row);	
		
	}
	
	return $out;

}

function prv_actionManagementUpdate() {

	// Update
	
	if (!getVar("enabled")) setVar("enabled", "0");
	if (!getVar("onetime")) setVar("onetime", "0");

	$id = sanitize("id");
	$enabled = sanitize("enabled");
	$name = sanitize("name");
	$description = sanitize("description");
	$threshold = sanitize("threshold");
	$thresholdtime = sanitize("thresholdtime");
	$onetime = sanitize("onetime");
	$matchtype = sanitize("matchtype");
	
	$q = $_ENV['appDB']->query("UPDATE idsActionMaster SET enabled = '$enabled', name = '$name', description = '$description', threshold = '$threshold', thresholdtime = '$thresholdtime', onetime = '$onetime', matchtype = '$matchtype' WHERE id = '$id'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementCustomEmailUpdate() {

	// Update
	
	$id = sanitize("id");
	$emailSubject = sanitize("emailSubject");
	$emailBody = sanitize("emailBody");

	$email = sanitize("email");
	$emailName = sanitize("emailName");
	
	$q = $_ENV['appDB']->query("UPDATE idsActionMaster SET senderName = '$emailName', senderEmail = '$email', senderSubject = '$emailSubject', senderBody = '$emailBody' WHERE id = '$id'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Custom Email";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementCreate() {

	$id = sanitize("id");

	// Create default

	$subject = ops("site_consoleName") . " Alert (SIG_NAME)";
	
	$body = "The following alert was generated by the " . ops("site_consoleName") . " Intrusion Detection Console.\n---\n\n";
	$body .= "Timestamp: TIMESTAMP\n\n";
	$body .= "Risk Level: RISK_LEVEL\n\n";
	$body .= "Source IP: SOURCE_IP : SOURCE_PORT\n";
	$body .= "Destination IP: DESTINATION_IP : DESTINATION_PORT\n";
	$body .= "Sensor: SENSOR\n\n";
	$body .= "Detected Event: SIG_NAME (SIG_NAME_ID)\n\n";
	$body .= "Detected Event Category: SIG_CLASS (SIG_CLASS_ID)\n\n";
	$body .= "" . ops("site_consoleName") . " ID: AANVALID\n";
	$body .= "Action ID: ACTIONID\n";
	$body .= "---\n";
	$body .= "Payload:\n";
	$body .= "PAYLOAD\n";

	$q = $_ENV['appDB']->query("INSERT INTO idsActionMaster (userid, name, enabled, matchtype, threshold, thresholdcount, intime, count, description, onetime, thresholdtime, thresholdeventtime, deleted, senderSubject, senderBody) VALUES ('" . $_SESSION['user']['id'] . "', 'New Action', 0, 1, 0, 0, '" . time() . "', 0, 'This action is not yet configured', 0, 30, 0, 0, '" . addslashes($subject) . "', '" . addslashes($body) . "')");
	
	$id = mysql_insert_id();
		
    // Redirect

    $_ENV['redirect'] = array("prv_actionManagement&id=$id", DEFAULT_REDIRECT_TIMEOUT);

    $_ENV['redirectMessage'] = "Creating Action";

    $_ENV['template'] = "template_redirectGeneral.php";
		
}

function prv_actionManagementDelete() {

	$id = sanitize("id");

	// Delete

	$_ENV['appDB']->query("DELETE FROM idsActionMaster WHERE id = '$id'");
	$_ENV['appDB']->query("DELETE FROM idsActionStore WHERE masterid = '$id'");
		
    // Redirect

    $_ENV['redirect'] = array("prv_actionManagement", DEFAULT_REDIRECT_TIMEOUT);

    $_ENV['redirectMessage'] = "Deleting Action";

    $_ENV['template'] = "template_redirectGeneral.php";
		
}

function prv_actionManagementCriteriaAdd() {

	$id = sanitize("id");
	$type = sanitize("type");
	$data = sanitize("data");

	if ($type) {

		$q = $_ENV['appDB']->query("INSERT INTO idsActionStore (masterid, class, type, data, intime) VALUES ('$id', '1', '$type', '$data', '" . time() . "') ");
		
	}

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementCriteriaUpdate() {

	$id = sanitize("id");
	$cid = sanitize("cid");

	$data = sanitize("data");

	$q = $_ENV['appDB']->query("UPDATE idsActionStore SET data = '$data' WHERE id = '$cid'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementCriteriaDelete() {

	$id = sanitize("id");
	$cid = sanitize("cid");

	$_ENV['appDB']->query("DELETE FROM idsActionStore WHERE id = '$cid'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementActionAdd() {

	$id = sanitize("id");
	$type = sanitize("type");
	$data = sanitize("data");

	if ($type) {

		$q = $_ENV['appDB']->query("INSERT INTO idsActionStore (masterid, class, type, data, intime) VALUES ('$id', '2', '$type', '$data', '" . time() . "') ");
		
	}

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementActionUpdate() {

	$id = sanitize("id");
	$cid = sanitize("cid");

	$data = sanitize("data");

	$q = $_ENV['appDB']->query("UPDATE idsActionStore SET data = '$data' WHERE id = '$cid'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementActionDelete() {

	$id = sanitize("id");
	$cid = sanitize("cid");

	$_ENV['appDB']->query("DELETE FROM idsActionStore WHERE id = '$cid'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

function prv_actionManagementResetCounter() {

	// Reset counter
	
	$id = sanitize("id");
	
	$q = $_ENV['appDB']->query("UPDATE idsActionMaster SET `count` = '0' WHERE id = '$id'");

    // Redirect

    $_ENV['redirect'] = array("prv_actionManagementEdit&id=$id", DEFAULT_REDIRECT_TIMEOUT);
    $_ENV['redirectMessage'] = "Updating Action";

    $_ENV['template'] = "template_redirectGeneral.php";

}

?>