<?php

function prv_consoleLogs() {

	$_ENV['contentTitle'] = "Console Logs";

	$_ENV['templateData'] = consoleLogData();

	$_ENV['template'] = "template_consoleLogs.php";

}

function consoleLogData() {

	$consoleSortOrder = sanitize("consoleSortOrder");
	
	if (!$consoleSortOrder)
		$consoleSortOrder = "ASC";

	$errorSortOrder = sanitize("errorSortOrder");
	
	if (!$errorSortOrder)
		$errorSortOrder = "ASC";

	if ($logFile = file_get_contents("logs/console.log")) {
	
		$logFile = nl2br($logFile,true);

		$logArray = explode("<br />",$logFile);
		
		if ($consoleSortOrder == "DESC")
			$logArray = array_reverse($logArray);
		
		for ($x = 0; $x < count($logArray); $x++) {
		
			if (strlen($logArray[$x]) > 1)
				$logArray[$x] = "<div class=\"renderDivRow\"><table style=\"width: 100%; height: 100%;\"><tr><td>" . $logArray[$x] . "</td></tr></table></div>";
			else
				$logArray[$x] = "";
		
		}
		
		$log['console'] = implode("",$logArray);
	
	} else {
	
		$log['console'] = "<span class=\"errorMessage\">Error opening console log file.</span>";
	
	}

	unset($logFile);
	unset($logArray);

	if ($logFile = file_get_contents("logs/error.log")) {
	
		$logFile = nl2br($logFile,true);

		$logArray = explode("<br />",$logFile);
		
		if ($errorSortOrder == "DESC")
			$logArray = array_reverse($logArray);
		
		for ($x = 0; $x < count($logArray); $x++) {
		
			if (strlen($logArray[$x]) > 1)
				$logArray[$x] = "<div class=\"renderDivRow\"><table style=\"width: 100%; height: 100%;\"><tr><td>" . $logArray[$x] . "</td></tr></table></div>";
			else
				$logArray[$x] = "";
		
		}
		
		$log['error'] = implode("",$logArray);
	
	} else {
	
		$log['error'] = "<span class=\"errorMessage\">Error opening error log file.</span>";
	
	}

	return arrayToObject($log);

}

?>