<?php

function prv_myReports() {

	// Build renderers

	$_ENV['templateRenderer'] = displayReportsByUserID($_SESSION['user']['id']);

	// Get details

	$_ENV['templateData'] = reportDetails(sanitize("id"));

	// Template

	$_ENV['contentTitle'] = "My Reports";

	$_ENV['template'] = "template_myReports.php";

}

function prv_viewReport_HTML() {

	// Get details

	$_ENV['templateData'] = reportDetails(sanitize("id"));

	// Template

	$_ENV['contentTitle'] = "Report Display";

	$_ENV['template'] = "template_reportDisplay_HTML.php";

}

function prv_viewReport_XML() {

	// Get details

	$_ENV['templateData'] = reportDetails(sanitize("id"));

	// Template

	$_ENV['contentTitle'] = "Report Display";

	$_ENV['template'] = "template_reportDisplay_XML.php";

}

function prv_viewReport_text() {

	// Get details

	$_ENV['templateData'] = reportDetails(sanitize("id"));

	// Template

	$_ENV['contentTitle'] = "Report Display";

	$_ENV['template'] = "template_reportDisplay_text.php";

}

function displayAllReports() {
	
	// Report list

	$q = $_ENV['appDB']->query("SELECT * FROM idsReportSchedule ORDER BY intime DESC");
	while ($row = mysql_fetch_assoc($q)) {
	
		if (!getVar("id")) setVar("id", $row['id']);
	
		$out .= itemRenderer('myReports', $row);	
		
	}
	
	return $out;

}

function displayReportsByUserID($id) {

	// Report list

	$q = $_ENV['appDB']->query("SELECT * FROM idsReportSchedule WHERE userid = '" . $id . "' ORDER BY intime DESC");
	while ($row = mysql_fetch_assoc($q)) {
	
		if (!getVar("id")) setVar("id", $row['id']);
	
		$out .= itemRenderer('myReports', $row);	
		
	}
	
	return $out;

}

function reportDetails($id) {
	
	$q = $_ENV['appDB']->query("SELECT * FROM idsReportSchedule WHERE id = '$id'");
	$result = mysql_fetch_object($q);
	
	if ($result->status == 2) {
	
		if (strlen($result->data) > 100) {
        	$result->xml = new SimpleXMLElement($result->data);
        }
	
	}
	
	return $result;
	
}

function prv_myReportsUpdate() {

	$id = sanitize("id");
	$name = sanitize("name");

	// Update report details

	$_ENV['appDB']->query("UPDATE idsReportSchedule SET name = '$name' WHERE id = '$id'");
		
    // Redirect

    $_ENV['redirect'] = array("prv_myReports&id=$id", DEFAULT_REDIRECT_TIMEOUT);

    $_ENV['redirectMessage'] = "Updating Report";

    $_ENV['template'] = "template_redirectGeneral.php";
		
}

function prv_myReportsDelete() {

	$id = sanitize("id");

	// Delete report

	$_ENV['appDB']->query("DELETE FROM idsReportSchedule WHERE id = '$id'");
		
    // Redirect

    $_ENV['redirect'] = array("prv_myReports", DEFAULT_REDIRECT_TIMEOUT);

    $_ENV['redirectMessage'] = "Deleting Report";

    $_ENV['template'] = "template_redirectGeneral.php";
		
}

function buildTextDataOutput($title,$templateXMLData,$prependName="") {

	$out = $title . "\n";

	foreach ($templateXMLData as $data)
		$out .= number_format((int)$data->total) . " : " . $prependName . $data->name . "\n";

	$out .= "\n";

	return $out;

}

function viewReportTextData() {

	$out .= "Report Details\n\n";

	$out .= "Generated: " . $_ENV["templateData"]->xml->data->generatedText . "\n\n";

	$out .= "Query: " . $_ENV["templateData"]->xml->data->searchText . "\n\n";

	$out .= "Confidentiality Statement\n";
	$out .=  $_ENV["templateData"]->xml->data->confidentialText . "\n\n";

	$out .= "Objective\n";
	$out .= $_ENV["templateData"]->xml->data->objectiveText . "\n\n";

	$out .= "Results\n";
	$out .= $_ENV["templateData"]->xml->data->reportStatistics->item->name . ": " . number_format((int)$_ENV["templateData"]->xml->data->reportStatistics->item->total) . "\n\n";

	$out .= buildTextDataOutput("Sensor Summary",$_ENV["templateData"]->xml->data->sensorSummary->item);
	$out .= buildTextDataOutput("Priority Summary",$_ENV["templateData"]->xml->data->prioritySummary->item,"Risk Level ");
	$out .= buildTextDataOutput("Module Summary",$_ENV["templateData"]->xml->data->moduleSummary->item);
	$out .= buildTextDataOutput("Datastore Summary",$_ENV["templateData"]->xml->data->datastoreSummary->item);
	$out .= buildTextDataOutput("Signature Summary",$_ENV["templateData"]->xml->data->signatureSummary->item);
	$out .= buildTextDataOutput("Category Summary",$_ENV["templateData"]->xml->data->classSummary->item);
	$out .= buildTextDataOutput("Protocol Summary",$_ENV["templateData"]->xml->data->protocolSummary->item);
	$out .= buildTextDataOutput("Source Port Summary",$_ENV["templateData"]->xml->data->sportSummary->item);
	$out .= buildTextDataOutput("Destination Port Summary",$_ENV["templateData"]->xml->data->dportSummary->item);
	$out .= buildTextDataOutput("Source Address Summary",$_ENV["templateData"]->xml->data->sipSummary->item);
	$out .= buildTextDataOutput("Destination Address Summary",$_ENV["templateData"]->xml->data->dipSummary->item);
/*
	$out .= "Sensor Summary\n";
	foreach ($_ENV["templateData"]->xml->data->sensorSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Priority Summary\n";
	foreach ($_ENV["templateData"]->xml->data->prioritySummary->item as $data)
		$out .= number_format((int)$data->total) . " : Risk Level " . $data->name . "\n";
	$out .= "\n";

	$out .= "Module Summary\n";	
	foreach ($_ENV["templateData"]->xml->data->moduleSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Datastore Summary\n";
	foreach ($_ENV["templateData"]->xml->data->datastoreSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Signature Summary\n";
	foreach ($_ENV["templateData"]->xml->data->signatureSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Category Summary\n";
	foreach ($_ENV["templateData"]->xml->data->classSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Protocol Summary\n";
	foreach ($_ENV["templateData"]->xml->data->protocolSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Source Port Summary\n";
	foreach ($_ENV["templateData"]->xml->data->sportSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Destination Port Summary\n";
	foreach ($_ENV["templateData"]->xml->data->dportSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Source Address Summary\n";
	foreach ($_ENV["templateData"]->xml->data->sipSummary->item as $data) 
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";

	$out .= "Destination Address Summary\n";
	foreach ($_ENV["templateData"]->xml->data->dipSummary->item as $data)
		$out .= number_format((int)$data->total) . " : " . $data->name . "\n";
	$out .= "\n";
*/
	return $out;

}

?>