<?php 

$dateTimeRange = sanitize("dateTimeRange");
$dateTimeOptions = array();

$dateTimeOptions[] = "all^All";
$dateTimeOptions[] = "today^Today";
$dateTimeOptions[] = "lastHour^Last Hour";
$dateTimeOptions[] = "last24Hours^Last 24 Hours";
$dateTimeOptions[] = "thisWeek^This Week";
$dateTimeOptions[] = "thisMonth^This Month";
$dateTimeOptions[] = "lastWeek^Last Week";
$dateTimeOptions[] = "lastMonth^Last Month";
$dateTimeOptions[] = "selectRange^Other (Enter Date Range)";

$currentTimeArray = getdate(consoleTimeConversion(time()));

if (sanitize('dateTimeRange') == "selectRange") {

	$dateFormTDDisplayDefault = "inline";
	$dateFormTDVisibilityDefault = "visible";

	$startMonthSelectedValue = sanitize('startMonth');
	$startDateSelectedValue = sanitize('startDate');
	$startYearSelectedValue = sanitize('startYear');
	$startHourSelectedValue = sanitize('startHour');
	$startMinuteSelectedValue = sanitize('startMinute');
	$startAMPMSelectedValue = sanitize('startAMPM');

	$endMonthSelectedValue = sanitize('endMonth');
	$endDateSelectedValue = sanitize('endDate');
	$endYearSelectedValue = sanitize('endYear');
	$endHourSelectedValue = sanitize('endHour');
	$endMinuteSelectedValue = sanitize('endMinute');
	$endAMPMSelectedValue = sanitize('endAMPM');


} else {

	$dateFormTDDisplayDefault = "none";
	$dateFormTDVisibilityDefault = "hidden";

	$startMonthSelectedValue = $currentTimeArray['mon'];
	$startDateSelectedValue = $currentTimeArray['mday'];
	$startYearSelectedValue = $currentTimeArray['year'];
	$startMinuteSelectedValue = $currentTimeArray['minutes'] - ($currentTimeArray['minutes'] % 5);

	if ($currentTimeArray['hours'] > 12)
		$startHourSelectedValue = $currentTimeArray['hours'] - 12;
	else
		$startHourSelectedValue = $currentTimeArray['hours'];

	if ($currentTimeArray['hours'] >= 12)
		$startAMPMSelectedValue = "PM";
	else
		$startAMPMSelectedValue = "AM";
	
	$endMonthSelectedValue = $startMonthSelectedValue;
	$endDateSelectedValue = $startDateSelectedValue;
	$endYearSelectedValue = $startYearSelectedValue;
	$endMinuteSelectedValue = $startMinuteSelectedValue;
	$endHourSelectedValue = $startHourSelectedValue;
	$endAMPMSelectedValue = $startAMPMSelectedValue;

}


?>

<script type="text/javascript">

    var chart;

    <?php
    
    	echo $_ENV['templateData']->chart . ";";
    	
   	?>            

    AmCharts.ready(function () {

        chart = new AmCharts.AmPieChart();
        chart.dataProvider = chartData;
        chart.titleField = "host";
        chart.valueField = "total";
        chart.outlineColor = "#FFFFFF";
        chart.outlineAlpha = 0.8;
        chart.outlineThickness = 2;

        chart.labelText = "[[percents]]%";

        var legend = new AmCharts.AmLegend();
        chart.addLegend(legend);

        // WRITE
        chart.write("chartdiv1");
        
    });

    function dateSelectorChange() {

		var fm = document.forms['filters'];

		if (fm['dateTimeRange'].value != 'selectRange') {

    		fm.submit();
    		
		} else {

			document.getElementById('dateFormTD').style.display = 'inline';
			document.getElementById('dateFormTD').style.visibility = 'visible';
			

    	}

    }

</script>

<table width="100%" style="height: 100%;">

	<tr>
	
		<td valign="top">
		
			<form method="POST" name="filters" action="?op=prv_frequentTargets">
			<table width="100%">
			
				<tr>
				
					<td>
					
						<p><a href="?op=prv_chartsGraphs">Charts & Graphs</a> &gt; Frequent Targets</p>
					
					</td>
					<td width="50%" style="text-align: right; font-size: 13px;">
					
						<select name="dateTimeRange" id="dateTimeRange" onChange="dateSelectorChange()">
							<?php 

								foreach ($dateTimeOptions as $thisTimeOption) {

									$tmpOptionsArray = explode("^",$thisTimeOption);
									echo "<option value=\"" . $tmpOptionsArray[0] . "\"";

									if ($dateTimeRange == $tmpOptionsArray[0])
										echo " SELECTED";

									echo ">" . $tmpOptionsArray[1] . "</option>";

								}

							?>

						</select>
					
						<input type="checkbox" name="resolve" value="1" <?php if (sanitize("resolve") == 1) echo "checked"; ?> onchange="this.form.submit();"/> Resolve Host names
					
						&nbsp;&nbsp;
					
						<input type="radio" name="type" value="2" <?php if (sanitize("type") == 2) echo "checked"; ?> onchange="this.form.submit();"> Infrequent					
						<input type="radio" name="type" value="1" <?php if (sanitize("type") == 1) echo "checked"; ?> onchange="this.form.submit();"> Frequent

						&nbsp;&nbsp;

						<select name="num" onchange="this.form.submit();">
							<option value="10" <?php if (sanitize("num") == 10) echo "selected"; ?>>10</option>
							<option value="25" <?php if (sanitize("num") == 25) echo "selected"; ?>>25</option>
							<option value="50" <?php if (sanitize("num") == 50) echo "selected"; ?>>50</option>
							<option value="100" <?php if (sanitize("num") == 100) echo "selected"; ?>>100</option>
						</select>
						
						</form>
						
					</td>
				
				</tr>

								<tr>
				
					<td id="dateFormTD" colspan="2" align="right" style="padding-top: 10px; display: <?php echo $dateFormTDDisplayDefault; ?>; visibility: <?php echo $dateFormTDVisibilityDefault; ?>; font-size: 12px;">
						<?php echo $_ENV['templateData']->errorText; ?>

						<select name="startMonth">

							<?php

								for ($i = 1; $i <= 12; $i++) {
									echo "<option value=\"" . $i . "\"";

									if ($i == $startMonthSelectedValue)
										echo " SELECTED";

									echo ">" . date("F", mktime(0, 0, 0, $i, 1)) . "</option>";
						
								}

							?>

						</select>

						<select name="startDate">

							<?php

								for ($i = 1; $i <= 31; $i++) {
					
									echo "<option value=\"" . $i . "\"";

									if ($i == $startDateSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						<select name="startYear">

							<?php

								for ($i = ($currentTimeArray['year'] - 10); $i <= $currentTimeArray['year']; $i++) {

									echo "<option value=\"" . $i . "\"";

									if ($i == $startYearSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						at

						<select name="startHour">

							<?php

								for ($i = 1; $i <= 12; $i++) {
					
									echo "<option value=\"" . $i . "\"";

									if ($i == $startHourSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						<select name="startMinute">
 
							<?php

								for ($i = 0; $i < 60; $i+=5) {
					
									echo "<option value=\"" . $i . "\"";

									if ($i == $startMinuteSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						<select name="startAMPM">
				
							<option value="AM"<?php if ($startAMPMSelectedValue == "AM") echo " SELECTED"; ?>>AM</option>
							<option value="PM"<?php if ($startAMPMSelectedValue == "PM") echo " SELECTED"; ?>>PM</option>
				
						</select>

						&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;

						<select name="endMonth">

							<?php

								for ($i = 1; $i <= 12; $i++) {
									echo "<option value=\"" . $i . "\"";

									if ($i == $endMonthSelectedValue)
										echo " SELECTED";

									echo ">" . date("F", mktime(0, 0, 0, $i, 1)) . "</option>";
						
								}

							?>

						</select>

						<select name="endDate">

							<?php

								for ($i = 1; $i <= 31; $i++) {
					
									echo "<option value=\"" . $i . "\"";

									if ($i == $endDateSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						<select name="endYear">

							<?php

								for ($i = ($currentTimeArray['year'] - 10); $i <= $currentTimeArray['year']; $i++) {

									echo "<option value=\"" . $i . "\"";

									if ($i == $endYearSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						at

						<select name="endHour">

							<?php

								for ($i = 1; $i <= 12; $i++) {
					
									echo "<option value=\"" . $i . "\"";

									if ($i == $endHourSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						<select name="endMinute">

							<?php

								for ($i = 0; $i < 60; $i+=5) {
					
									echo "<option value=\"" . $i . "\"";

									if ($i == $endMinuteSelectedValue)
										echo " SELECTED";

									echo ">" . $i . "</option>";
						
								}

							?>

						</select>

						<select name="endAMPM">
				
							<option value="AM"<?php if ($endAMPMSelectedValue == "AM") echo " SELECTED"; ?>>AM</option>
							<option value="PM"<?php if ($endAMPMSelectedValue == "PM") echo " SELECTED"; ?>>PM</option>
				
						</select>

						<input type="submit" value="Filter" />

					</td>
				
				</tr>

			</table>
			</form>			
			<br>
			<hr>
			<br>
		
		</td>
	
	</tr>

	<tr style="height: 100%;">
	
		<td valign="top">

			<table width="100%" style="height: 100%;">
			
				<tr>
				
					<td>
			
						<table width="100%" style="height: 100%;">
						
							<tr>
							
								<td>
								
									<div style="overflow-y: scroll; height: 100%; padding-right: 10px;">
						
										<?php
										
										echo $_ENV['templateData']->table;
														
										?>
									
									</div>
								
								</td>
							
							</tr>
							
							<tr style="height: 50%;">
							
								<td>
								
									<br>
									<hr>
								
									<div id="mapdiv" style="width: 100%; height: 100%;"></div>
								
								</td>
							
							</tr>
						
						</table>
						
					</td>
					
					<td width="10">&nbsp;</td>
					<td bgcolor="#CDCDCD" width="1"></td>
					<td width="10">&nbsp;</td>
					
					<td width="425" valign="top">
					
						<div id="chartdiv1" style="width:100%; height: 100%;"></div>
					
					</td>
					
				</tr>
				
			</table>
		
		</td>
	
	</tr>

</table>