<?php 

$num = sanitize("num");
$sortColumn = sanitize("sortColumn");
$sortDirection = sanitize("sortDirection");
$untaggedOnly = sanitize("untaggedOnly");
$sensorIDsToSearch = sanitize("sensorIDsToSearch");
$tagID = sanitize("tagID");
$tagFilter = sanitize("tagFilter");

if (!$sortColumn)
	$sortColumn = "timestamp";

if (!$sortDirection)
	$sortDirection = "DESC";

if (!$num)
	$num = 25;

?>

<script>

function checkUncheckAllTags() {

	var isChecked = document.getElementById("checkUncheckAllTagsCheckbox").checked;
	var checkboxes = document.getElementsByName("tagEventCheckbox[]");

	for (var i in checkboxes) {

		checkboxes[i].checked = isChecked;

	}

}

</script>

<table style="width: 100%; height: 100%;">

	<tr style="height: 100%; border: 0px solid #CECECE;">	

		<td valign="top" style="padding-right: 10px;">

			<form name="tagEvents" method="post" action="?op=prv_tagEvents">

			<input type="hidden" name="num" value="<?php echo $num; ?>">
			<input type="hidden" name="sortColumn" value="<?php echo $sortColumn; ?>">
			<input type="hidden" name="sortDirection" value="<?php echo $sortDirection; ?>">
			<input type="hidden" name="untaggedOnly" value="<?php echo $untaggedOnly; ?>">
			<input type="hidden" name="sensorIDsToSearch" value="<?php echo $sensorIDsToSearch; ?>">
			<input type="hidden" name="tagFilter" value="<?php echo $tagFilter; ?>">

			<p><a href="?op=prv_myOptions">My Options</a> &gt; Tag Events</p>

			<hr>
			<br>

			<table style="width: 100%; height: 100%;">

				<tr style="heigh: 38px; border-bottom: 1px solid #F1F1F1;">

					<td width="24" title="Select or Deselect All Events" style="text-align: left; padding-left: 7px; padding-bottom: 10px;"><input type="checkbox" name="checkUncheckAllTagsCheckbox" id="checkUncheckAllTagsCheckbox" onChange="checkUncheckAllTags()"></td>

					<td style="text-align: right; vertical-align: middle; padding-bottom: 10px; font-size: 13px; color: #04B404; font-weight: bold;">

						<?php if ($_ENV['templateData']->tagMessage != "") echo $_ENV['templateData']->tagMessage; ?>

						<select name="tagID">

						<?php

							foreach ($_ENV['templateData']->tags AS $thisTag) {

								echo "<option value=\"" . $thisTag["id"] . "\"";

								if ($tagID == $thisTag["id"])
									echo " selected";

								echo ">" . $thisTag["name"] . "</option>";

							}

						?>

						</select>

						<input type="submit" value="Tag Selected Events">

					</td>

				</tr>

			</table>

			<?php

				if ($_ENV['templateData']->events)
					echo $_ENV['templateData']->events;
				else
					echo "No events to display";

			?>

			</form>

		</td>

		<td class="separator"></td>

		<td valign="top" width="300" style="padding-left: 10px;">

			<p>Events</p>

			<hr>
			<br>

			<table class="noBorder" style="width: 100%;">

				<tr>

					<td style="font-size: 0.8em;">					

						<form method="POST" action="?op=prv_tagEvents">

							<input type="hidden" name="tagID" value="<?php echo $tagID; ?>">
							<input type="checkbox" value="1" name="untaggedOnly"<?php if ($untaggedOnly && $untaggedOnly == 1) echo " checked"; ?>>&nbsp;View Untagged Events Only

							<br><br>

							<input type="hidden" name="didSubmit" value="1">

							<span style="width: 55px; display: inline-block;">View</span> <select name="num">

								<option value="10"<?php if ($num == 10) echo " selected"; ?>>10</option>
								<option value="15"<?php if ($num == 15) echo " selected"; ?>>15</option>
								<option value="25"<?php if ($num == 25) echo " selected"; ?>>25</option>
								<option value="50"<?php if ($num == 50) echo " selected"; ?>>50</option>
								<option value="100"<?php if ($num == 100) echo " selected"; ?>>100</option>
								<option value="all"<?php if ($num == "all") echo " selected"; ?>>All</option>

							</select> Events

							<br><br>

							<span style="width: 55px; display: inline-block;">Sensors</span> <select name="sensorIDsToSearch">

								<?php

									foreach ($_ENV['templateData']->sensors AS $thisSensor) { 

										if ($sensorIDsToSearch == $thisSensor["id"])
											echo "<option value=\"" . $thisSensor["id"] . "\" selected>" . $thisSensor["name"] . "</option>";
										else
											echo "<option value=\"" . $thisSensor["id"] . "\">" . $thisSensor["name"] . "</option>";

									}

								?>

							</select>

							<br><br>

							<span style="width: 55px; display: inline-block;">Tag</span> <select name="tagFilter">

							<option value="">All</option>

						<?php

							foreach ($_ENV['templateData']->tags AS $thisTag) {

								echo "<option value=\"" . $thisTag["id"] . "\"";

								if ($tagFilter == $thisTag["id"])
									echo " selected";

								echo ">" . $thisTag["name"] . "</option>";

							}

						?>

						</select>

						<br><br>

							<span style="width: 55px; display: inline-block;">Sort By</span><select name="sortColumn">

								<option value="timestamp"<?php if ($sortColumn == "timestamp") echo " selected"; ?>>Date</option>
								<option value="priority"<?php if ($sortColumn == "priority") echo " selected"; ?>>Priority</option>
								<option value="signatureName"<?php if ($sortColumn == "signatureName") echo " selected"; ?>>Signature</option>
								<option value="className"<?php if ($sortColumn == "className") echo " selected"; ?>>Class</option>
								<option value="sensorID"<?php if ($sortColumn == "sensorID") echo " selected"; ?>>Sensor</option>

							</select>

							<select name="sortDirection">

								<option value="ASC"<?php if ($sortDirection == "ASC") echo " selected"; ?>>Ascending</option>
								<option value="DESC"<?php if ($sortDirection == "DESC") echo " selected"; ?>>Descending</option>

							</select>
							<!--  
							<br><br>

							Source IP <input type="text" name="sourceIP" style="width: 100px;">&nbsp;&nbsp;Source Port <input type="text" name="soucePort" style="width: 33px;">

							<br><br>

							Dest. IP <input type="text" name="destinationIP" style="width: 100px;">&nbsp;&nbsp;Source Port <input type="text" name="destinationPort" style="width: 33px;">
							-->
							<br><br>

							<input type="submit" value="View Events">

						</form>

					</td>					

				</tr>

			</table>

		</td>

	</tr>

</table>